Attribute VB_Name = "MathProcs"
Public Const Pi = 3.14159265358979



Public Type point
    X As Double
    Y As Double
    Z As Double
    W As Double
End Type

Public Type Vector
    i As Double
    j As Double
    k As Double
    l As Double
End Type

Public Type Plane
    X0 As Double
    Y0 As Double
    Z0 As Double
    W0 As Double
    i As Double
    j As Double
    k As Double
    l As Double
End Type

Type Matrix
    value(3, 3) As Double 'Rows X Columns
End Type
    
Function SetPoint(X, Y, Z, W) As point
Dim pt As point
pt.X = X
pt.Y = Y
pt.Z = Z
pt.W = W
SetPoint = pt
End Function
Function SetVector(X, Y, Z, W) As Vector
Dim pt As Vector
pt.i = X
pt.j = Y
pt.k = Z
pt.l = W
SetVector = pt
End Function
   
    

Function PlaneRotate(ax1, ax2, ByVal Theta) As Matrix
Theta = Theta * (Pi / 180)
Dim mat As Matrix
mat = matInit
For X = 0 To 3
    mat.value(X, X) = 1
Next
mat.value(ax1, ax1) = Round(Cos(Theta), 10)
mat.value(ax1, ax2) = Round(Sin(Theta), 10)
mat.value(ax2, ax1) = Round(-Sin(Theta), 10)
mat.value(ax2, ax2) = Round(Cos(Theta), 10)
PlaneRotate = mat
End Function

Function VectorRotate(Axis As Vector, ByVal Theta As Double) As Matrix
Theta = Theta * (Pi / 180)
Dim mat As Matrix
mat = matInit

ct = Cos(Theta)
st = Sin(Theta)
vt = 1 - ct

Dim u As Vector
u = UnitVect(Axis)

mat.value(0, 0) = u.i ^ 2 * vt + ct
mat.value(0, 1) = u.i * u.j * vt - u.k * st
mat.value(0, 2) = u.i * u.k * vt + u.j * st
mat.value(1, 0) = u.i * u.j * vt + u.k * st
mat.value(1, 1) = u.j ^ 2 * vt + ct
mat.value(1, 2) = u.j * u.k * vt - u.i * st
mat.value(2, 0) = u.i * u.k * vt - u.j * st
mat.value(2, 1) = u.j * u.k * vt + u.i * st
mat.value(2, 2) = u.k ^ 2 * vt + ct

VectorRotate = mat
End Function


Function translate(pt As point, Trans As point) As point
Dim pt1 As point
pt1.X = Trans.X + pt.X
pt1.Y = Trans.Y + pt.Y
pt1.Z = Trans.Z + pt.Z
pt1.W = Trans.W + pt.W
translate = pt1
End Function

Function Collapse(Axis, Look, collapseVal) As Matrix
Dim mat As Matrix
mat = matInit
If collapseVal <> 0 Then
    ans = Look / collapseVal
Else
    ans = 999999999
End If
mat.value(0, 0) = ans
mat.value(1, 1) = ans
mat.value(2, 2) = ans
mat.value(3, 3) = ans


mat.value(Axis, Axis) = 0

Collapse = mat
End Function

Function MatMult(pt As point, mat As Matrix) As point
Dim prod As point
prod.X = mat.value(0, 0) * pt.X + mat.value(0, 1) * pt.Y + mat.value(0, 2) * pt.Z + mat.value(0, 3) * pt.W
prod.Y = mat.value(1, 0) * pt.X + mat.value(1, 1) * pt.Y + mat.value(1, 2) * pt.Z + mat.value(1, 3) * pt.W
prod.Z = mat.value(2, 0) * pt.X + mat.value(2, 1) * pt.Y + mat.value(2, 2) * pt.Z + mat.value(2, 3) * pt.W
prod.W = mat.value(3, 0) * pt.X + mat.value(3, 1) * pt.Y + mat.value(3, 2) * pt.Z + mat.value(3, 3) * pt.W
MatMult = prod
End Function


Function matInit() As Matrix
Dim mat As Matrix
For X = 0 To 3
    For Y = 0 To 3
        mat.value(X, Y) = 0
    Next
Next
matInit = mat
End Function

Function CrossProduct(A As Vector, B As Vector) As Vector
Dim prd As Vector
prd.i = A.j * B.k - A.k * B.j
prd.j = -A.i * B.k + A.k * B.i
prd.k = A.i * B.j - A.j * B.i
CrossProduct = prd
End Function

Function UnitVect(v As Vector) As Vector
Dim u As Vector
l = VectorLen(v)
u.i = v.i / l
u.j = v.j / l
u.k = v.k / l
u.l = v.l / l
UnitVect = u
End Function

Function VectorLen(v As Vector) As Double
Dim l As Double
l = Sqr(v.i ^ 2 + v.j ^ 2 + v.k ^ 2 + v.l ^ 2)
VectorLen = l
End Function
